<script type="text/html" data-help-name="dim-rpc in">
  <p>A DIM Server node providing a Remote Procedure Call service.</p>
  <h3>Outputs</h3>
  <dl class="message-properties">
    <dt>payload<span class="property-type">string | number | array</span></dt>
    <dd>The RPC's input parameters received.</dd>
    <dt>res<span class="property-type">object</span></dt>
    <dd>
      The RPC response object. This property should not be used directly; it
      will be used by a DIM RPC Response to send the response to the client.
    </dd>
  </dl>
  <h3>Details</h3>
  <p>
    This node registers a RPC service on a DIM Name Server (DNS). A connection
    to the DNS Server is required for this purpose, which can be created by
    clicking on the pencil icon or selecting an existing one shared between
    several DIM nodes.
  </p>
  <p>The service consists of:</p>
  <ul>
    <li><i>Service Name</i>, the service identifier. It must be unique for a
      given DNS Server and comply the following
      <a target="_blank" href="https://www.rfc-editor.org/info/rfc5234">
        abnf syntax
      </a>:
      <pre><b>part *( "/" part )</b>
        <br>part = (ALPHA / DIGIT) *body
        <br>body = (ALPHA / DIGIT / "-" / "+" / "_" / "." / ":")</pre>
    <li><i>Service Definition IN</i>, the input data content that the service
      provide.
    <li><i>Service Definition OUT</i>, the output data content that the service
      provide.
  </ul>
  <p>
    Both definitions must match the following
    <a target="_blank" href="https://www.rfc-editor.org/info/rfc5234">
      abnf syntax
    </a>:
    <pre><b>*(type ":" num ";") type [":" num]</b>
      <br>type = "C" / "S" / "I" / "X" / "F" / "D"
      <br>num = 1*DIGIT</pre>
    where types are:
    <table style="outline-width:#888 solid thin">
      <tr><th width="50px">type</th><th width="80px">description</th></tr>
      <tr><td><center>C</center></td><td><center>string</center></td></tr>
      <tr><td><center>S</center></td><td><center>int16</center></td></tr>
      <tr><td><center>I</center></td><td><center>int32</center></td></tr>
      <tr><td><center>X</center></td><td><center>int64</center></td></tr>
      <tr><td><center>F</center></td><td><center>float</center></td></tr>
      <tr><td><center>D</center></td><td><center>double</center></td></tr>
    </table>
  </p>
  <p>
    <b>Examples</b>:
    <ul>
      <li><i>Service Name</i>: <pre>/rpc/name/test</pre>
      <li><i>Service Definition IN</i>: <pre>C</pre>
      <li><i>Service Definition OUT</i>: <pre>I:1;F:2</pre>
    </ul>
  </p>
  <p>
    <b>Note</b>: This node does not send any response to the DIM RPC Client.
    The flow must include a <code>DIM RPC Response</code> node to complete the
    RPC request.
  </p>
</script>

<script type="text/html" data-help-name="dim-rpc-response">
  <p>
    A DIM node for sending RPC service's result back as response to requests
    received from a DIM RPC Input node.
  </p>
  <h3>Inputs</h3>
  <dl class="message-properties">
    <dt>
      payload
      <span class="property-type">string | number | buffer | object</span>
    </dt>
    <dd>The RPC's output to be sent back. If this property is not set, no
      output will be sent.</dd>
    <dt>res<span class="property-type">object</span></dt>
    <dd>
      This is necessary for sending the response to the client and <b>must</b>
      come from a <code>DIM RPC Input</code> node.
    </dd>
  </dl>
  <h3>Details</h3>
  <p>
    This node is meant to return the result of a RPC service invoked by a DIM
    RPC Client, allowing an intermediate processing stage.
  </p>
  <p>
    It must be used in conjunction with a <code>DIM RPC Input</code> node since
    it needs the <code>msg.res</code> property created by the latter in order
    to respond to the requesting client.
  </p>
</script>
